#line 1 "C:/Users/Usuario/Documents/MikroC_programas/MikroC_program/PWM/PWM.c"



sbit LCD_RS at RD2_bit;
sbit LCD_EN at RD3_bit;
sbit LCD_D4 at RD4_bit;
sbit LCD_D5 at RD5_bit;
sbit LCD_D6 at RD6_bit;
sbit LCD_D7 at RD7_bit;
sbit LCD_RS_Direction at TRISD2_bit;
sbit LCD_EN_Direction at TRISD3_bit;
sbit LCD_D4_Direction at TRISD4_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D7_Direction at TRISD7_bit;


unsigned char ch;
unsigned int adc_rd;
unsigned int division;
char *text;
long tlong;

void main() {

 INTCON = 0;
 ANSEL = 0x04;
 ANSELH = 0;
 TRISA = 0x04;
 TRISC = 0;
 PORTC = 0;
 C1ON_bit = 0;
 C2ON_bit = 0;
 PWM1_Init(10000);
 Lcd_Init();
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Cmd(_LCD_CLEAR);
 text = "PWM_Controller";
 Lcd_Out(1,1,text);
 text = "Cycle_Duty:";
 Lcd_Out(2,1,text);
 ADCON1 = 0x82;
 Delay_ms(2000);
 PWM1_Start();

 while (1) {
 adc_rd = ADC_Read(2);
 Delay_ms(1);
 tlong = (long)adc_rd * 255;
 tlong = tlong / 1023;
 ch = tlong/100;
 Lcd_Chr(2,12,48+ch);
 ch = (tlong / 10) % 10;
 Lcd_Chr_CP(48+ch);
 ch = tlong % 10;
 Lcd_Chr_CP(48+ch);
 division = adc_rd/4;
 PWM1_Set_Duty(division);
 Delay_ms(850);
 }
}
